{***************************************************************
 *
 * Unit Name : CServGif
 * Purpose   : Compuserve GIF Interface
 * Author    : Eugen Mihailescu
 * Company   : EM Quicksoft Romania SRL
 * Copyright : 1998,2002  All rights reserved.
 * Web Site  : http://www.em-quicksoft.com
 * Support   : support@em-quicksoft.com
 * History   : 03/17/2000
 *
 ****************************************************************}

Unit CServGif;

Interface
Uses
  Classes,
  Graphics,
  GIFImage;

Procedure gifRegisterGraphicClass(aName: String; aGraphicClass: TGraphicClass);
Procedure gifUnRegisterGraphicClass(aGraphicClass: TGraphicClass);

Function gifGraphicClasses: TStringList;

Implementation
Var
  FGraphicClasses   : TStringList = Nil;
  //******************* gifRegisterGraphicClass *************************

Procedure gifRegisterGraphicClass(aName: String; aGraphicClass: TGraphicClass);
Var
  liIndex           : Integer;
Begin

  If gifGraphicClasses.Find(aName, liIndex) Then
    gifGraphicClasses.Objects[liIndex] := TObject(aGraphicClass)
  Else
    gifGraphicClasses.AddObject(aName, TObject(aGraphicClass));

End;
//******************* gifUnRegisterGraphicClass *************************

Procedure gifUnRegisterGraphicClass(aGraphicClass: TGraphicClass);
Var
  liIndex           : Integer;
Begin

  If (FGraphicClasses = Nil) Then Exit;

  liIndex := gifGraphicClasses.IndexOfObject(TObject(aGraphicClass));

  If liIndex >= 0 Then
    gifGraphicClasses.Delete(liIndex);

end;
//******************* gifGraphicClasses *************************

Function gifGraphicClasses: TStringList;
Begin

  If FGraphicClasses = Nil Then
    Begin
      FGraphicClasses := TStringList.Create;

      {register default graphic classes}
      gifRegisterGraphicClass('Bitmap', TBitmap);
      gifRegisterGraphicClass('MetaFile', TMetaFile);
      gifRegisterGraphicClass('Icon', TIcon);

      {look for the TGIFImage class}
      If GetClass('TGIFImage') <> Nil Then
        gifRegisterGraphicClass('GIF', TGraphicClass(GetClass('TGIFImage')));

      FGraphicClasses.Sorted := True;
    End;

  Result := FGraphicClasses;

End;

End.

